Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test	(revision 2271)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/run_test	(revision 2272)
@@ -98,5 +98,5 @@
     do
       mkdir -p ${rundir}/def_files/${svnR}/${i%%} ; CHMOD ${rundir}/def_files/${svnR}/${i%%}
-      cp ${i%%}/user_param.json ${rundir}/def_files/${svnR}/${i%%}
+      cp ${i%%}/user_param_*.json ${rundir}/def_files/${svnR}/${i%%}
       for j in $(ls -d ${i%%/}/CONFIG_*)
       do
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2271)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/step1.py	(revision 2272)
@@ -23,9 +23,10 @@
 def OSinfo(runthis):
     red = lambda text: '\033[0;31m' + text + '\033[0m'
-    osstdout = subprocess.Popen(runthis, shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, close_fds=True)
-    theInfo = osstdout.communicate()[0].strip()
-    if osstdout.returncode!=0:
+    osstdout = subprocess.Popen(runthis, shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, close_fds=True)
+    theInfo, theErr = osstdout.communicate()
+    #print( theInfo )
+    if theErr:
         print(red(runthis+" FAILED"))
-        print(theInfo)
+        print(theErr)
         sys.exit()
 
@@ -44,4 +45,10 @@
     def_param=dict(l)
     return def_param
+
+def get_test_type():
+    test_type = "basic"
+    if ( machine == "irene" ):
+        test_type = "advanced"
+    return test_type
 
 def generate_job(fn, n):
@@ -165,8 +172,11 @@
     #print(default_param)
 
+    # default = basic, function( machine, arch, mode )
+    test_type = get_test_type()
+
     for test_folder in test_folder_list:
         config_list=[]
         config_name=[]
-        with open(test_folder+"/user_param.json", "r") as f:
+        with open(test_folder+"/user_param_"+test_type+".json", "r") as f:
             config_dict = json.load(f)
 
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,9 +1,0 @@
-[
-	{
-		"Domain": ["lmdz"],
-		"UseServer2": ["false"],
-		"NumberServers": [2, 4],
-        "AxisMask": ["false","true"],
-        "DomMask": ["false","true"]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,9 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"UseServer2": ["false"],
+		"NumberServers": [2, 4],
+        "AxisMask": ["false","true"],
+        "DomMask": ["false","true"]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_axis_algo/user_param_basic.json	(revision 2272)
@@ -0,0 +1,9 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"UseServer2": ["false"],
+		"NumberServers": [2, 4],
+        "AxisMask": ["false"],
+        "DomMask": ["false"]
+	}
+]
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,8 +1,0 @@
-[
-	{
-		"Domain": ["lmdz"],
-		"NumberServers": [2],
-		"DomMask": ["false","true"],
-		"AxisMask": ["false","true"]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"NumberServers": [2],
+		"DomMask": ["false","true"],
+		"AxisMask": ["false","true"]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_domain_algo/user_param_basic.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"NumberServers": [2],
+		"DomMask": ["false"],
+		"AxisMask": ["false"]
+	}
+]
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,8 +1,0 @@
-[
-	{
-		"Domain": ["dynamico"],
-		"NumberServers": [2],
-		"DomMask": ["false","true"],
-		"AxisMask": ["false"]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["dynamico"],
+		"NumberServers": [2],
+		"DomMask": ["false","true"],
+		"AxisMask": ["false"]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_dynamico_algo/user_param_basic.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["dynamico"],
+		"NumberServers": [2],
+		"DomMask": ["false"],
+		"AxisMask": ["false"]
+	}
+]
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,7 +1,0 @@
-[
-	{
-		"Domain": ["lmdz"],
-		"UseServer2": ["false"],
-		"NumberServers": [2, 4]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,7 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"UseServer2": ["false"],
+		"NumberServers": [2, 4]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_function/user_param_basic.json	(revision 2272)
@@ -0,0 +1,7 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"UseServer2": ["false"],
+		"NumberServers": [2, 4]
+	}
+]
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,6 +1,0 @@
-[
-	{
-		"NumberServers": [2],
-		"OneSided": ["false"]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,6 @@
+[
+	{
+		"NumberServers": [2],
+		"OneSided": ["false"]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_grid_algo/user_param_basic.json	(revision 2272)
@@ -0,0 +1,6 @@
+[
+	{
+		"NumberServers": [2],
+		"OneSided": ["false"]
+	}
+]
Index: OS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param.json	(revision 2271)
+++ 	(revision )
@@ -1,8 +1,0 @@
-[
-	{
-		"Domain": ["lmdz"],
-		"NumberServers": [2, 4],
-		"AxisMask": ["false","true"],
-		"DomMask": ["false","true"]
-	}
-]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_advanced.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_advanced.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_advanced.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"NumberServers": [2, 4],
+		"AxisMask": ["false","true"],
+		"DomMask": ["false","true"]
+	}
+]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_basic.json
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_basic.json	(revision 2272)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param_basic.json	(revision 2272)
@@ -0,0 +1,8 @@
+[
+	{
+		"Domain": ["lmdz"],
+		"NumberServers": [2, 4],
+		"AxisMask": ["false"],
+		"DomMask": ["false"]
+	}
+]